import React, { Component } from 'react'
// import PropTypes from 'prop-types'
import styles from './index.css'

class EllipsisText extends Component {

	// static propTypes = {
	// 	text: PropTypes.string.isRequired,
	// 	className: PropTypes.string
	// }

	componentDidMount() {
		// const test = document.body.getBoundingClientRect();
		this.checkWidth.bind(this)();
		// requestAnimationFrame(this.checkWidth.bind(this));
	}

	componentDidUpdate() {
		// const test = document.body.getBoundingClientRect();
		this.checkWidth.bind(this)();
		// requestAnimationFrame(this.checkWidth.bind(this));
	}

	checkWidth(fixLength) {
		fixLength = fixLength || 0;
		if (this.selfEl && this.textEl && this.el) {
			const parentEl = this.selfEl.parentElement;
			const containerWidth = parentEl.getBoundingClientRect().width;
			const textWidth = this.textEl.getBoundingClientRect().width;

			let text = this.props.text;

			if (textWidth > containerWidth) {
				const shouldCutLength = Math.ceil((textWidth - containerWidth) / textWidth * text.length + fixLength);
				const startIndex = Math.floor(text.length / 2 - shouldCutLength / 2);
				const endIndex = Math.ceil(text.length / 2 + shouldCutLength / 2);
				const start = text.substring(0, startIndex);
				const end = text.substring(endIndex, text.length);
				text = `${start}...${end}`;
			}
			this.el.textContent = text;
			const realWidth = this.el.getBoundingClientRect().width;
			if (realWidth > containerWidth) {
				fixLength += 1;
				this.checkWidth.bind(this)(fixLength);
			}
		}
	}

	render() {

		return (
			<div {...this.props} ref={(el) => this.selfEl = el} >
				<span className={styles.slave} ref={(el) => this.textEl = el}>{this.props.text}</span>
				<span className={styles.nowrap} ref={(el) => this.el = el}>&nbsp;</span>
			</div>
		)
	}
}

export default EllipsisText;
